/* Copyright (c) 2006-2008 Dovecot Sieve authors, see the included COPYING file */

#include "common.h"
#include "str.h"
#include "managesieve-quote.h"
#include "commands.h"

#include <stdlib.h>

bool cmd_noop(struct client_command_context *cmd)
{
	struct client *client = cmd->client;
	struct managesieve_arg *args;
    const char *text;
	int ret;

    /* [<echo string>] */
    if (!(ret=client_read_args(cmd, 0, 0, &args)))
      return FALSE;

    if ( ret > 1 ) {
        client_send_no(client, "Too many arguments");
        return TRUE;
    }

	if ( args[0].type == MANAGESIEVE_ARG_EOL ) {
		client_send_ok(client, "NOOP");
		return TRUE;
	}

    if ( (text = managesieve_arg_string(&args[0])) == NULL ) {
        client_send_no(client, "Invalid echo string.");
        return TRUE;
    }

	client_send_ok(client, text);
	return TRUE;
}

